<template>
  <ContentWrap>
    <!-- 搜索工作栏 -->
    <el-form
      class="-mb-15px"
      :model="queryParams"
      ref="queryFormRef"
      :inline="true"
      label-width="68px"
    >
      <el-form-item :label="t('deviceForm.category')" prop="deviceType" style="width: 15vw" >
        <el-tree-select
          v-model="queryParams.deviceType"
          :data="productClassifyList"
          :props="defaultProps"
          check-strictly
          node-key="id"
          :placeholder="t('deviceForm.categoryHolder')"
          filterable
        />
      </el-form-item>
      <el-form-item :label="t('info.faultySystem')" prop="failureSystem">
        <el-input
          v-model="queryParams.failureSystem"
          :placeholder="t('info.faultySystemHolder')"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item :label="t('info.createTime')" prop="createTime">
        <el-date-picker
          v-model="queryParams.createTime"
          value-format="YYYY-MM-DD HH:mm:ss"
          type="daterange"
          :start-placeholder="t('info.start')"
          :end-placeholder="t('info.end')"
          :default-time="[new Date('1 00:00:00'), new Date('1 23:59:59')]"
          class="!w-220px"
        />
      </el-form-item>
      <el-form-item>
        <el-button @click="handleQuery"><Icon icon="ep:search" class="mr-5px" />
          {{ t('info.search') }}</el-button>
        <el-button @click="resetQuery"><Icon icon="ep:refresh" class="mr-5px" />
          {{ t('info.reset') }}</el-button>
        <el-button
          type="primary"
          plain
          @click="openForm('create')"
          v-hasPermi="['rq:iot-information-db:create']"
        >
          <Icon icon="ep:plus" class="mr-5px" />
          {{ t('info.add') }}
        </el-button>
        <el-button
          type="success"
          plain
          @click="handleExport"
          :loading="exportLoading"
          v-hasPermi="['rq:iot-information-db:export']"
        >
          <Icon icon="ep:download" class="mr-5px" /> 导出
        </el-button>
      </el-form-item>
    </el-form>
  </ContentWrap>

  <!-- 列表 -->
  <ContentWrap>
    <el-table v-loading="loading" :data="list" :stripe="true" :show-overflow-tooltip="true">
      <el-table-column :label="t('iotDevice.serial')" width="70" align="center">
        <template #default="scope">
          {{ scope.$index + 1 }}
        </template>
      </el-table-column>
      <el-table-column :label="t('info.deviceClass')" align="center" prop="className" />
      <el-table-column :label="t('faultForm.faultImpact')" align="center" prop="failureInfluence" />
      <el-table-column :label="t('iotMaintain.faultySystem')" align="center" prop="failureSystem" />
      <el-table-column :label="t('info.description')" align="center" prop="description" />
      <el-table-column :label="t('iotMaintain.solution')" align="center" prop="solutions" />
      <el-table-column :label="t('iotMaintain.remark')" align="center" prop="remark" />
      <el-table-column
        :label="t('info.createTime')"
        align="center"
        prop="createTime"
        :formatter="dateFormatter"
        width="180px"
      />
      <!--      <el-table-column label="审核状态" align="center" prop="auditStatus" />-->
      <el-table-column :label="t('iotMaintain.operation')" align="center" min-width="120px">
        <template #default="scope">
          <el-button
            link
            type="primary"
            @click="openForm('update', scope.row.id)"
            v-hasPermi="['rq:iot-information-db:update']"
          >
            {{ t('info.edit') }}
          </el-button>
          <el-button
            link
            type="danger"
            @click="handleDelete(scope.row.id)"
            v-hasPermi="['rq:iot-information-db:delete']"
          >
            {{ t('info.delete') }}
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页 -->
    <Pagination
      :total="total"
      v-model:page="queryParams.pageNo"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />
  </ContentWrap>

  <!-- 表单弹窗：添加/修改 -->
  <IotInformationDbForm ref="formRef" style="width: 60vw" @success="getList" />
</template>

<script setup lang="ts">
import { dateFormatter } from '@/utils/formatTime'
import download from '@/utils/download'
import { IotInformationDbApi, IotInformationDbVO } from '@/api/pms/information'
import IotInformationDbForm from './IotInformationDbForm.vue'
import {defaultProps, handleTree} from "@/utils/tree";
import * as ProductClassifyApi from "@/api/pms/productclassify";

/** 故障知识库 列表 */
defineOptions({ name: 'IotInformationDb' })

const message = useMessage() // 消息弹窗
const { t } = useI18n() // 国际化

const loading = ref(true) // 列表的加载中
const list = ref<IotInformationDbVO[]>([]) // 列表的数据
const productClassifyList = ref<Tree[]>([]) // 树形结构
const total = ref(0) // 列表的总页数
const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  deviceType: undefined,
  failureInfluence: undefined,
  failureSystem: undefined,
  description: undefined,
  solutions: undefined,
  remark: undefined,
  createTime: [],
  processInstanceId: undefined,
  auditStatus: undefined
})
const queryFormRef = ref() // 搜索的表单
const exportLoading = ref(false) // 导出的加载中

/** 查询列表 */
const getList = async () => {
  loading.value = true
  try {
    const data = await IotInformationDbApi.getIotInformationDbPage(queryParams)
    list.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value.resetFields()
  handleQuery()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number) => {
  formRef.value.open(type, id)
}

/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await IotInformationDbApi.deleteIotInformationDb(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}

/** 导出按钮操作 */
const handleExport = async () => {
  try {
    // 导出的二次确认
    await message.exportConfirm()
    // 发起导出
    exportLoading.value = true
    const data = await IotInformationDbApi.exportIotInformationDb(queryParams)
    download.excel(data, '故障知识库.xls')
  } catch {
  } finally {
    exportLoading.value = false
  }
}

/** 初始化 **/
onMounted(async () => {
  productClassifyList.value = handleTree(
    await ProductClassifyApi.IotProductClassifyApi.getSimpleProductClassifyList()
  )
  await getList()
})
</script>
